#pragma once
#include <switch.h>
#include <unordered_map>

namespace lang
{
	struct Language
	{
		std::string langCode = "en";
		json Labels;
		std::unordered_map<int, std::string> labelMap;
	};
	
	enum Label {
		ABOUT_AUTHOR,
		ABOUT_CREDITS,
		ABOUT_DEVS,
		ABOUT_TESTERS,
		AMIIBO_DETAILS_FIRST_DATE,
		AMIIBO_DETAILS_LAST_DATE,
		AMIIBO_DETAILS_PATH,
		APP_NAME,
		BOOT_CREATING,
		BOOT_LOADING,
		BOOT_SETTINGS,
		BOOT_UPDATING,
		CANCEL,
		DISABLED,
		EMUIIBO_DISABLE,
		EMUIIBO_ENABLE,
		EMUIIBO_ENABLE_ONCE,
		EMUIIBO_SCAN,
		ENABLED,
		ERROR_NOT_INSTALLED,
		FOOTER_ABOUT,
		FOOTER_AMIIBO,
		FOOTER_AMIIBO_SELECT,
		FOOTER_EMUIIBO_DISABLE,
		FOOTER_EMUIIBO_ENABLE,
		FOOTER_EMUIIBO_ENABLE_ONCE,
		FOOTER_EMUIIBO_SCAN,
		FOOTER_GAMES,
		FOOTER_IMAGES_DELETE,
		FOOTER_IMAGES_RENAME,
		FOOTER_IMAGES_SEARCH,
		FOOTER_MAIN_ABOUT,
		FOOTER_MAIN_AMIIBO,
		FOOTER_MAIN_EMUIIBO,
		FOOTER_MAIN_IMAGES,
		FOOTER_MAIN_SELECTED_AMIIBO,
		FOOTER_MAIN_USER_MANUAL,
		FOOTER_SELECTED_AMIIBO,
		HEADER_AMIIBO,
		HEADER_EMUIIBO_ACTIVE,
		HEADER_EMUIIBO_ACTIVE_ONCE,
		HEADER_EMUIIBO_NOT_ACTIVE,
		HEADER_EMUIIBO_UNKNOWN,
		HEADER_NO_AMIIBO,
		HELP_ADD,
		HELP_BACK,
		HELP_FINISH,
		HELP_MANAGE,
		HELP_MINUS,
		HELP_OK,
		HELP_SELECT,
		HELP_TOGGLE,
		IMAGES_DELETE,
		IMAGES_RENAME,
		IMAGES_SEARCH,
		KEYBOARD_HINT,
		MAIN_ABOUT,
		MAIN_AMIIBO,
		MAIN_EMUIIBO,
		MAIN_IMAGES,
		MAIN_SELECTED_AMIIBO,
		MAIN_SETTINGS,
		MAIN_USER_MANUAL,
		NO,
		RANDOM_DIALOG_TEXT,
		RANDOM_DIALOG_TITLE,
		RANDOM_UUID,
		SELECT_DIALOG_TEXT,
		SELECT_DIALOG_TITLE,
		TOAST_ACTIVE_AMIIBO,
		TOAST_AMIIBO_ADDED,
		TOAST_AMIIBO_REMOVED,
		TOAST_EMUIIBO_DISABLED,
		TOAST_EMUIIBO_ENABLED,
		TOAST_EMUIIBO_ENABLED_ONCE,
		TOAST_EMUIIBO_NOT_INSTALLED,
		TOAST_EMUIIBO_SCAN,
		TOAST_GAMES_NO_AMIIBO,
		TOAST_GAME_ADDED,
		TOAST_GAME_ALL_CANT_DELETE,
		TOAST_GAME_ALL_POPULATED,
		TOAST_GAME_ALL_RESERVED,
		TOAST_GAME_REMOVED,
		TOAST_IMAGES_DELETED,
		TOAST_IMAGES_FOUND,
		TOAST_IMAGES_IMAGES,
		TOAST_IMAGES_RENAMED,
		TOAST_NO_AMIIBO,
		TOAST_RANDOM,
		TOGGLE,
		YES
	};

	void Initialize();
	void InitLabelMap();
	static Language MainLanguage;
	std::string GetLabel(Label);
	std::string GetLangCode();
}
